public AddAtoHL,WriterDEtoHL_B,WriteAll,OneHexToBCD,Delay6usProg,CmpAXBC,AddAXBC
libcseg	cseg
Delay6usProg:
	  NOP
	  NOP
	  NOP
	  NOP
	  NOP
	  NOP
	  NOP
	  NOP
	  NOP
	  NOP
	  NOP
	  NOP
	  RET 
AddAtoHL:
;a+hl->hl

		push	ax
		add a,l
		l = a
		a = #0
		addc a,h
		h = a
		pop	ax
		ret
;*************************************
;hl=source address
;de=des address
;b=datelength
;
;*************************************
WriterDEtoHL_B:
		[de]=[hl](a)
		de++
		hl++
		DBNZ	b,$WriterDEtoHL_B
		ret
;**********************************
;ܣʾͬ
;ڣA=Ҫ
;
;***********************************
WriteAll:
		[hl]=a
		hl++
		DBNZ	b,$WriteAll
		ret
OneHexToBCD:
;in:  A = Hex code
;out: AX = compressed BCD code
	
		if(a==#0)
			x=#0
			ret
		endif
		push	bc
		x = #0
		a <-> x
		c = #10
		call !DivideSubroutine
		a <-> c
		b =	a
		a = c
		c = #10
		call !DivideSubroutine
		a = c
		a <<= 4
		a &= #0f0h
		a += b
		a <-> x
		pop	bc
		ret
;********************************************************************
;       division subroutine
;           AX <- dividend[#word]
;           C  <- divisor[#byte]
;           get Quotient  in 'AX[#word]
;           get remainder in 'C[#byte]'
;********************************************************************
DivideSubroutine:

		;DIVUW C
	  
      PUSH    AX

      if(C!=#0H)(A)
           POP     AX
           PUSH    DE
           PUSH    HL
           PUSH    PSW

           DE=AX

;-------------------------------------
       	   A=B
           PUSH AX          ;  protect B register
;-------------------------------------

           B=#16D
           A=#0D
           XCH  A,C
           L=A              ;  L is constant 'divisor'
NextRotating:
           AX=DE
           CLR1 CY
           XCH  A,X
           ROLC A,1
           XCH  A,X
           ROLC A,1
           DE=AX
           A=C
           ROLC A,1
           C=A

           if_bit(!CY)
                SUB  A,L
                if_bit(!CY)
                    C=A
                    A=E
                    SET1 A.0
                    E=A
                endif
           else
                SUB  A,L
                C=A
                A=E
                SET1 A.0
                E=A
           endif
           DBNZ  B,$NextRotating

;--------
           POP    AX
           B=A
           ;--------

           AX=DE

           POP    PSW
           POP    HL
           POP    DE
      else
           POP    AX
      endif
      RET
      
;**********************************
;ܣȽaxbc
;ڣAx,bc
; cy z
;***********************************
CmpAXBC:
			a<->x
			sub a,c
			a=x
			subc a,b
			ret

AddAXBC:
			a<->x
			add a,c
			a<->x
			addc a,b
			ret
end