public SwitchMode,GetSysMode,GetDisinMode,GetValveMode,GetWashMode
public BookTime,mainpro,SystemState,GetWarnState,WarnState
public GetBookTimeHM,CheckMode,GetWashModeAll

;debug
public WarnState
extrn SelModeInit,WashTaskInit
extbit BuzzOn_fg
extrn error
extrn HaltWash,RunWash
extrn OutControl
extrn BuzzerOn,GetKey,HalfSec,BuzzerOff,GetPowerMode
extrn InPutByte
extrn	KeyPro,WashRun,DispPro
extrn CloseLcd
#include "sysdef.h"
;*******************************************
;״̬ת
;
;
;********************************************
sysdseg	dseg saddr
SystemState:	DS	1
WarnState:		DS	1
syscseg	cseg
;
;ܣ
;		ĵǰϴ״̬
;ڣx
;ڣa=ϴģʽ*8
;
GetWashMode:
		a=SystemState
		a&=#WASHMASK
		ret
;++++++++++++++++++++++++++++++++++++++++
;ܣ
;		л״̬
;ڣx
;
;++++++++++++++++++++++++++++++++++++++++
SwitchMode:
		OutControl=#0;
		a=SystemState
		a&=#(0ffh-SYSMASK)
		a+=x
		SystemState=a
		a=x
		switch (a)
		case RESETMODE:
			SystemState=#RESETMODE
		break
		case OPENMODE:
			SystemState=#OPENMODE
		break
		case SELMODE:
			call	!SelModeInit
			SystemState=#SELMODE
		break
		case BOOKMODE:
			call	!BookModeInit
		break
		case STOPMODE:
		break
		case RUNMODE:
			call	!WashTaskInit
		break
		case RUNENDMODE:
			call	!RunEndMInit
		break
		case CHECKMODE:
			call	!CheckModeInit
			SystemState=#CHECKMODE
		break
		default:
			goto error
		break
		ends
		ret
GetWashModeAll:
		a=SystemState
		a&=#(0ffh-SYSMASK)
		
		ret

;++++++++++++++++++++++++++++++++++++++++
;ܣ
;		ȡǰ״̬
;ڣ
;ڣa
;++++++++++++++++++++++++++++++++++++++++
GetSysMode:
		a=SystemState
		a&=#SYSMASK
		ret
;++++++++++++++++++++++++++++++++++++++++
;ܣ
;		ȡǰõ1/2״̬
;ڣ
;ڣcy
;++++++++++++++++++++++++++++++++++++++++
GetValveMode:
		if_bit(SystemState.VALVE_1_2)
			set1	cy
		else
			clr1	cy
		endif
		ret		
;++++++++++++++++++++++++++++++++++++++++
;ܣ
;		ȡǰõ1/2״̬
;ڣ
;ڣcy
;++++++++++++++++++++++++++++++++++++++++
GetDisinMode:
		if_bit(SystemState.DISINMODE)
			set1	cy
		else
			clr1	cy
		endif
		ret
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;ܣ
;     ȡǰı״̬
;ڣa
;
GetWarnState:
		if_bit(WarnState.OpenDoorE_fg)
			a=#1
		elseif_bit(WarnState.InWaterE_fg)
			a=#7
		elseif_bit(WarnState.OutWaterE_fg)
			a=#0dh
		elseif_bit(WarnState.SensorE_fg)
			a=#6
		elseif_bit(WarnState.FWaterE_fg)
			a=#0fh
		else
			a=#0
		endif
		ret



usercseg	cseg
;****************************************
;ܣнģʽʼ
;
;
;****************************************
RunEndMInit:
		a=#6
		call	!BuzzerOn
		ret
;****************************************
;ܣнģʽ
;
;
;****************************************
RunEndM:
		if_bit(!BuzzOn_fg)
			x=#RESETMODE
			call	!SwitchMode
		endif
		ret
;MainInit:
;		ret
mainpro:
MainLoop:
		call	!GetPowerMode
		if_bit(cy)
					call	!CloseLcd
					OutControl=#0
					while(forever)
						WDTE=#0ACH
						call	!GetPowerMode
						if_bit(!cy)
							while(forever)
							endw
						endif
					endw
		endif
		WDTE=#0ACH
		call	!DispPro
		call	!GetWarnMode
		call	!GetSysMode
		if(a!=#RESETMODE)
			if(WarnState!=#0)
				call	!WarnModePro
				goto	MainLoop
			endif
			switch(a)
			case OPENMODE:
				call	!KeyPro
			break
			case SELMODE:
				call	!KeyPro
			break
			case BOOKMODE:
				call	!KeyPro
				call	!BookPro
			break
			case STOPMODE:
			break
			case RUNMODE:
				call	!KeyPro
				call	!WashRun
			break
			case RUNENDMODE:
				call	!RunEndM
			break
			case CHECKMODE:
				call	!CheckPro
			break
			default:
				goto error
			break
			ends
		else
			call	!KeyPro
		endif
		goto	MainLoop
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;
;								ԤԼܴ
;		1ԤԼ״̬ʼ
;		2
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
bookdseg DSEG	SADDR
BookTime:		ds	1
BookSec:		ds	1
BookMin:		ds	1
BookMode:		ds	1
bookcseg	CSEG
;++++++++++++++++++++++++++++++++++++++++++
;ܣԤԼʱСʱһ

;++++++++++++++++++++++++++++++++++++++++++
BookTimeDec:
		BookTime--
		if((BookTime>#9)&&(BookTime<#10H))
				BookTime=#9
		endif
		ret
;++++++++++++++++++++++++++++++++++++++++
;ܣԤԼ״̬ʼ
;++++++++++++++++++++++++++++++++++++++++
BookModeInit:
		BookMode=#0
		BookSec=#0
		BookMin=#0
		ret
;++++++++++++++++++++++++++++++++++++++++++
;ܣȡԤԼСʱͷ
;ڣhl=ָ
;++++++++++++++++++++++++++++++++++++++++++
GetBookTimeHM:
		[hl+1]=BookTime(a)
		[hl]=BookMin(a)
		ret
;*********************************************
;ܣԤԼ
;			ʱʱʱ䵽ת״̬
;
;
;*********************************************
BookPro:
;--------ԤԼ״̬˳
		call	!GetSysMode
		if(a!=#BOOKMODE)
			goto error
		endif
		if_bit(!HalfSec.BookSec_fg)
			ret
		endif
		HalfSec.BookSec_fg=0;
;---------ԤԼʱ䵽
		if((BookTime==#0)&&(BookMin==#0))
			goto BookOut
		endif
		BookSec++
		if(BookSec>#119)
			BookSec=#0
			BookMin--
			if(BookMin>#60h)
				BookMin=#59h
				call	!BookTimeDec
			else
				a=BookMin
				a&=#0fh
				if(a>#9)
					a=BookMin
					a&=#0f0h
					a+=#9
					BookMin=a
				endif
			endif
		endif
		if((BookTime!=#0)||(BookMin!=#0))
;----------ԤԼʱûе
			ret
		endif
		BookMode=#1
BookOut:
		if(BookMode==#1)
			a=#2
			call	!BuzzerOn
			BookMode=#2
		elseif(BookMode==#2)
;----------ԤԼ
			if_bit(BuzzOn_fg)
				ret
			endif
			x=#RUNMODE
			call	!SwitchMode
		else			
			goto error
		endif
		ret
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;
;									Լ칦ܴ
;			1Լģʽǰĳʼ
;			2Լ
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

chkdseg	DSEG	saddr
;Լģʽ
CheckMode:	ds	1
CheckCnt:		ds	1
chkcseg	CSEG
;****************************************
;
;ܣԼģʽ
;
;***************************************
CheckModeInit:
		CheckMode=#0
		CheckCnt=#0
		ret
;**********************************************
;ܣ
;			Լģʽ
;			
;
;*********************************************
CheckPro:
		call	!GetKey
		if(cy)
			if(CheckMode==#4)
				OutControl=#0
				if(a==#KEY_1_2)
					a=#1
					call	!BuzzerOn
					CheckCnt=#0
					CheckMode++
				endif
			endif
		endif
		if_bit(!HalfSec.CheckSec_fg)
			ret
		endif
		HalfSec.CheckSec_fg=0
		CheckCnt++
		switch(CheckMode)
;-------ģʽ
		case	0:
					a=#3
					call	!BuzzerOn
		break
;-------ȴ2s
		case	1:
			if(CheckCnt<#4)
				ret
			endif
		break
;-------ȴˮλص
		case	2:
			OutControl=#1
			if_bit(!InPutByte.WaterL_fg)
				ret
			endif
		break
;-------ȴ35s
		case	3:
			OutControl=#1
			if(CheckCnt<#70)
				ret
			endif
			OutControl=#0
		break
;-------ȴs3
;		case	4:
;	;		ret
;		break
;-------ϴӼ5s
		case	5:
			OutControl=#40h
			if(CheckCnt<#10)
				ret
			endif
		break
;-------ϴӱù5s
		case	6:
			OutControl=#4
			if(CheckCnt<#10)
				ret
			endif
		break
;-------5s
		case	7:
			OutControl=#2
			if(CheckCnt<#10)
				ret
			endif
		break
;-------ˮù30s;
		case	8:
			OutControl=#8
			if(CheckCnt<#30)
				ret
			endif
		break
;-------ͷ5S
		case	9:
			OutControl=#0
			if(CheckCnt<#10)
				ret
			endif
		break
;-------ģʽ
		case	10:
			x=#RESETMODE
			call	!SwitchMode
			ret
		break
		default :
			ret
		break
		ends
		CheckCnt=#0
		CheckMode++
		ret
;//////////////////////////////////////////////////////////
;                                                        //
;										ͣģʽ                         //
;		1ɱģʽĻȡл                          //
;		2ɱ                                  //
;   3ͣ״̬ϵʼ                              //
;                                                        //
;//////////////////////////////////////////////////////////
stopdseg	DSEG	SADDRP 
WaterL:			ds	2
WarnBuzz:		Ds	1
WarnOutW:		Ds	1
StopCnt:		DS	1
stopcseg	CSEG
;*****************************************
;ܣͣģʽʼ
;
;
;*****************************************
;StopModeInit:
;			WaterL=#0(ax)
;			StopCnt=a
;			ret
;*****************************************
;ܣжǷǱ״̬
;
;
;*****************************************
GetWarnMode:
;--------ű
		call	!GetSysMode
;--------ֻ״̬ż⿪ű
		if(a==#RUNMODE)
			if_bit(!InPutByte.DoorOpen_fg)
				WarnState.OpenDoorE_fg=1;
				StopCnt=#60
			else
				WarnState.OpenDoorE_fg=0;
			endif
		endif
;--------ˮؼⲻɻָ
		if_bit(InPutByte.FWaterL_fg)
			WarnState.FWaterE_fg=1;
		endif
;--------
		if_bit(InPutByte.DoorOpen_fg)
			if_bit(InPutByte.Sensor_fg)
				WarnState.SensorE_fg=1;
			else
				WarnState.SensorE_fg=0;
			endif
		endif
;-------ˮ
		if_bit(HalfSec.WarnSec_fg)
			HalfSec.WarnSec_fg=0;
			ax=WaterL
			ax++
			if_bit(OutControl.Inlet_fg)
				if(!InPutByte.WaterL_fg)
					if(ax>=#120)
						ax=#120
						WarnState.InWaterE_fg=1;
					endif
				else
					ax=#0
				endif
			elseif_bit(OutControl.Drain_fg)
;--------ˮ
				if(InPutByte.WaterL_fg)
					if(ax>=#600)
						ax=#600
						if(!WarnState.OutWaterE_fg)
							WarnState.OutWaterE_fg=1;
							WarnOutW=#0
						endif
					endif
				else
					ax=#0
					WarnState.OutWaterE_fg=0;
				endif
			else
				ax=#0
			endif
			WaterL=ax
		endif
		
		ret
;*********************************************
;ܣ̬ͣ״̬л
;
;ڣx=ģʽ
;*********************************************
SwitchWarn:
		a=WarnState
		a&=#(0ffh-WARNMASK)
		a+=x
		WarnState=a
		ret

;*********************************************
;ܣ̬ͣ
;
;
;*********************************************
WarnModePro:
		if_bit(!HalfSec.StopSec_fg)
			ret
		endif
		HalfSec.StopSec_fg=0
		a=WarnState
		a&=#WARNMASK
		switch(a)
		case	WARNBEGIN:;-----̬뱨̬
				x=#WARNMODE
				call	!SwitchWarn
				WarnBuzz=#0
				;------ֹͣϴ
				call	!HaltWash
		case	WARNMODE:;------̬
				a=WarnState
				a&=#(0ffh-WARNMASK)
				if(a==#0);----źŽ
					;-----뱨̬
					x=#WAENENDMODE
					call	!SwitchWarn
					a=#1
					call	!BuzzerOn
				endif
				;------
				if(WarnBuzz==#0)
					a=#10
					call	!BuzzerOn
				endif
				WarnBuzz++
				if(WarnBuzz>#80)
					WarnBuzz=#0
				endif
				;------ˮش
				if_bit(WarnState.OutWaterE_fg)
					WarnOutW++
					if(WarnOutW>#30)
						WarnOutW=#0
						OutControl.Drain_fg=1;ˮ
					elseif(WarnOutW>#10)
						OutControl.Drain_fg=0;ˮ
					else
						OutControl.Drain_fg=1;ˮ
					endif
				endif
				;------ˮػ
				if_bit(WarnState.FWaterE_fg)
					if(InPutByte.FWaterL_fg)
						OutControl.Drain_fg=1;
					else
						OutControl.Drain_fg=0;
					endif
				endif
		break
		case	WAENENDMODE:;------̬
			a=WarnState
			a&=#(0ffh-WARNMASK)
			if(a!=#0);----ź³
				;-----뱨̬
				x=#WARNMODE
				call	!SwitchWarn
				
			endif
			if(StopCnt==#0)
				;------̬
				x=#WARNBEGIN
				call	!SwitchWarn
				call	!BuzzerOff
				call	!RunWash
				ret
			endif
			StopCnt--
		break
		ends
		ret

end